package f00f.net.napster.japster.messages;

import java.util.Hashtable;

import f00f.net.napster.japster.messages.server.ServerMessage;
import f00f.net.napster.japster.messages.server.UnknownMessage;

public class MessageFactory
{
	private Hashtable hash = new Hashtable();	

	public void registerMessage(ServerMessage message)
	{
		hash.put(new Short(message.getTypeCode()), message);
	}
	
	public ServerMessage parseMessage(short type, String data)
	{
		ServerMessage message = (ServerMessage)hash.get(new Short(type));
	
		if (message == null)
		{
			UnknownMessage uMessage = new UnknownMessage(data);
			uMessage.setTypeCode(type);
			return uMessage;
		}
		return message.getInstance(data);
	}
	
}
