package f00f.net.napster.japster.messages.client;

public class Search extends ClientMessage
{

	public Search()
	{
	}
	
	public Search(String artist, String song, int max)
	{
		append("FILENAME CONTAINS");
		append("\""+artist+"\"");
		append("MAX_RESULTS");
		append(max);
		if (song != null)
		{
			append("FILENAME CONTAINS");
			append("\""+song+"\"");
		}
	}
	
	public void setSearchParam(String name, String compare, String value)
	{
		append(name);
		if (compare.equals("="))
			append("\"EQUAL TO\"");
		else if (compare.equals("<"))
			append("\"AT BEST\"");
		else if (compare.equals(">"))
			append("\"AT LEAST\"");
		append(value);
	}
	
	public void setBitRate(String compare, int value)
	{
		setSearchParam("BITRATE", compare,
			(new Integer(value)).toString());
	}
	
	public void setLineSpeed(String compare, int value)
	{
		setSearchParam("LINESPEED", compare,
			(new Integer(value)).toString());
	}
	
	public void setFrequency(String compare, int value)
	{
		setSearchParam("FREQ", compare,
			(new Integer(value)).toString());
	}
	
	public short getTypeCode()
	{
		return 0xc8;
	}
	
	public String toString()
	{
		return "Search: "+getData();
	}
}
