
package f00f.net.napster.japster.util;

import java.util.StringTokenizer;

public class DataTokenizer extends StringTokenizer
{
	public DataTokenizer(String data)
	{
		super(data, " \"", true);
	}
	
	public int nextTokenInt()
	{
		String token = nextToken();
		Long value = new Long(token);
		return value.intValue();
	}

	public long nextTokenLong()
	{
		String token = nextToken();
		Long value = new Long(token);
		return value.longValue();
	}
	
	public String nextTokenIP()
	{
		String token = nextToken();
		long value = (new Long(token)).longValue();
		int digit4 = (int)(value % 256);
		value = value / 256;
		int digit3 = (int)(value % 256);
		value = value / 256;
		int digit2 = (int)(value % 256);
		value = value / 256;
		int digit1 = (int)(value % 256);
		
		String s1 = (new Integer(digit1)).toString();
		String s2 = (new Integer(digit2)).toString();
		String s3 = (new Integer(digit3)).toString();
		String s4 = (new Integer(digit4)).toString();
		
		return s4+"."+s3+"."+s2+"."+s1;
	}

	public String nextToken()
	{
		String token = super.nextToken();
		// find the next non-space token
		while (token.equals(" "))
			token = super.nextToken();
		
		// if we found a ", we need to read everything until the next ".
		if (token.equals("\""))
		{
			StringBuffer buffer = new StringBuffer();
			while ( !(token = super.nextToken()).equals("\"") )
			{
				buffer.append(token);
			}
			return buffer.toString();
		}
		else
		{
			return token;
		}
	
	}
}
