package f00f.net.napster.japster.util;

import java.util.Vector;
import java.util.Enumeration;
import java.util.Hashtable;

import f00f.net.napster.japster.messages.server.SearchResult;

public class SearchResults extends Vector
{

	public SearchResults()
	{
	}
	
/*	public int size()
	{
		return results.size();
	}*/
	
	private SearchResults(Vector results)
	{
		Enumeration enum = results.elements();
		while (enum.hasMoreElements())
		{
			add( enum.nextElement() );
		}
	}

	public void addResult(SearchResult result)
	{
		add(result);
	}
	
/*	public Enumeration getResults()
	{
		return elements();
	}*/
	
	public int findMeanValue(int field)
	{
		Enumeration enum = elements();
		Hashtable hash = new Hashtable();
		while (enum.hasMoreElements())
		{
			SearchResult result = (SearchResult)enum.nextElement();
			Integer value = new Integer(result.getField(field));
			if (hash.get(value) == null)
				hash.put(value, new Integer(1));
			else
			{
				Integer count = (Integer)hash.get(value);
				count = new Integer( count.intValue()+1 );
				hash.put(value, count);
			}
		}
		Integer value = null;
		int count = 0;
		
		enum = hash.keys();
		while (enum.hasMoreElements())
		{
			Integer key = (Integer)enum.nextElement();
			int x = ((Integer)hash.get(key)).intValue();
			if (x > count)
			{
				value = key;
				count = x;
			}
		}
		
		return value.intValue();
	}

	public SearchResults trimFieldGreaterThan(int field, int value)
	{
		SearchResults results = new SearchResults(this);
		int x = 0;
		while (x < results.size())
		{
			SearchResult result = (SearchResult)results.elementAt(x);

			if (result.getField(field) > value)
				results.removeElementAt(x);
			else
				++x;
		}
		return results;
	}
	
	public SearchResults trimFieldLessThan(int field, int value)
	{
		SearchResults results = new SearchResults(this);
		int x = 0;
		while (x < results.size())
		{
			SearchResult result = (SearchResult)results.elementAt(x);

			if (result.getField(field) < value)
				results.removeElementAt(x);
			else
				++x;
		}
		return results;
	}
	
    public void sort(int field) throws Exception
	{
        for (int i = 1; i < size(); i++)
		{
            int j = i;
            SearchResult B = (SearchResult)elementAt(i);//a[i];
            while ((j > 0) && (((SearchResult)elementAt(j-1)).getField(field)
				< B.getField(field) /*a[j-1] > B*/))
			{
//                a[j] = a[j-1];
				setElementAt( elementAt(j-1) ,j);
                j--;
//                pause(i,j);
            }
//            a[j] = B;
			setElementAt(B, j);
//            pause(i,j);
        }
    }
}
