package f00f.net.napster.japster.messages.server;

public class UnknownMessage implements ServerMessage
{
	private StringBuffer data = new StringBuffer();
	private short type = -1;
	
	public UnknownMessage()
	{
	}
	
	public UnknownMessage(String data)
	{
		this.data = new StringBuffer(data);
	}
	
	public void setTypeCode(short type)
	{
		this.type = type;
	}

	public short getTypeCode()
	{
		return type;
	}
	
	public String getData()
	{
		return data.toString();
	}
	
	public ServerMessage getInstance(String data)
	{
		return new UnknownMessage(data);
	}
	
	public String toString()
	{
		return "UnknownMessage: length=" + data.length() + " type=" +
			Integer.toHexString( type ) + " data=" + data;
	}
}
