package f00f.net.napster.japster.messages.shared;

import java.util.StringTokenizer;
import f00f.net.napster.japster.messages.server.ServerMessage;
import f00f.net.napster.japster.messages.client.ClientMessage;

public class ServerStats extends ClientMessage implements ServerMessage
{
	public static final short TYPECODE = 0x00d6;

	private int users;
	private int files;
	private int size;
	
	public ServerStats()
	{
	}
	
	public ServerStats(int users, int files, int size)
	{
		this.users = users;
		this.files = files;
		this.size = size;
	}
	
	public short getTypeCode()
	{
		return TYPECODE;
	}
	
	public String getData()
	{
		return "";//users+" "+files+" "+size;
	}
	
	public ServerMessage getInstance(String data)
	{
		StringTokenizer tok = new StringTokenizer(data);
		return new ServerStats( (new Integer(tok.nextToken())).intValue(),
			(new Integer(tok.nextToken())).intValue(),
			(new Integer(tok.nextToken())).intValue());

	}
	
	public String toString()
	{
		return "ServerStats: users="+users+" files="+files+" size="+size;
	}
}
